Subject: [FIAT-dev] Re: orientation

From: Anders Logg <[email-masked]>
Date: Mon, 16 May 2005 16:24:29 -0500

On Mon, May 16, 2005 at 04:03:38PM -0500, Robert Kirby wrote:
> Anders,
> 1.) Triangles are fine.

ok, good.

> 2.) Edges on tets are fine -- I think that's what I've got in FIAT 
> already.

In shapes.py it says

tetrahedron_edges = {0:(1,2), \
                     1:(2,3), \
                     2:(3,1), \
                     3:(3,0), \
                     4:(0,2), \
                     5:(0,1)}

According to my convention, I would like to have

	  1 2
	  2 0
	  0 1
	  0 3
	  1 3
	  2 3

This is formula (4) in the FFC manual.

> 3.) I don't know about faces.  Our convention for edges is just one of 
> convenience, and I like the aesthetics of i-->( (i+1)%4,(i+2)%4,(i+3)%4 
> ) as they match with how we define edges on triangles.  That doesn't 
> have the external orientation that your approach has, but we will have 
> to handle orientation one way or the other.

In shapes.py it says

tetrahedron_faces = {0:(1,2,3), \
                     1:(0,3,2), \
                     2:(0,1,3), \
                     3:(0,2,1)}

If I understand your convention correctly, it should be

	  1 2 3
	  2 3 0
	  3 0 1
	  0 1 2

Right?

I can live with that. I will change formula (5)	in the FFC manual if
this is what you mean.

> I will not have the time to sit down and work this into FIAT before I 
> go, but I will do it soon after I get back.  While I'm setting this up, 
> I might as well put a wrapper onto the tabulation of basis functions to 
> get them working on the (0,1) interval as well.

Thanks.

I will have plenty to do anyway with implementing the
projections/interpolations.

/Anders